﻿public class ReceiverAutoOff : Mod
{
    private static ReceiverAutoOff receiverAutoOff;
    private HarmonyLib.Harmony harmony;
    private static string modId = "com.raftmodding.mods.receiver-autooff";
    private static System.Collections.Generic.IDictionary<Reciever, UnityEngine.Coroutine> receivers = new System.Collections.Generic.Dictionary<Reciever, UnityEngine.Coroutine>();
    public void Start()
    {
        receiverAutoOff = this;
        receivers.Clear();
        harmony = new HarmonyLib.Harmony(modId);
        harmony.PatchAll();
        RestartAutoOffAll();
    }
    public override void WorldEvent_WorldLoaded()
    {
        receivers.Clear();
        RestartAutoOffAll();
    }
    public void OnModUnload()
    {
        harmony.UnpatchAll(modId);
    }
    private System.Collections.IEnumerator TimerAutoOff(Reciever receiver)
    {
        yield return new UnityEngine.WaitForSeconds(60);
        receivers.Remove(receiver);
        receiver.battery.On = false;
    }
    private void RestartAutoOff(Reciever receiver)
    {
        UnityEngine.Coroutine coroutine;
        if (receivers.TryGetValue(receiver, out coroutine))
        {
            StopCoroutine(coroutine);
        }
        receivers.Remove(receiver);
        if (receiver.battery.On)
        {
            coroutine = StartCoroutine(TimerAutoOff(receiver));
            receivers.Add(receiver, coroutine);
        }
    }
    private void RestartAutoOffAll()
    {
        foreach (Reciever receiver in UnityEngine.Resources.FindObjectsOfTypeAll<Reciever>())
        {
            if (receiver.battery)
            {
                RestartAutoOff(receiver);
            }
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(Anchor_Stationary), "DropAnchor")]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.Low)]
    public class HarmonyPatch_AnchorStationary_DropAnchor
    {
        static void Prefix()
        {
            receiverAutoOff.RestartAutoOffAll();
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(Anchor_Stationary), "WeighAnchor")]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.Low)]
    public class HarmonyPatch_AnchorStationary_WeighAnchor
    {
        static void Prefix()
        {
            receiverAutoOff.RestartAutoOffAll();
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(Anchor_Throwable), "OnThrow")]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.Low)]
    public class HarmonyPatch_AnchorThrowable_OnThrow
    {
        static void Prefix()
        {
            receiverAutoOff.RestartAutoOffAll();
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(Anchor_Throwable_Stand), "OnDestroy")]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.Low)]
    public class HarmonyPatch_AnchorThrowableStand_OnDestroy
    {
        static void Prefix()
        {
            receiverAutoOff.RestartAutoOffAll();
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(Binoculars), "Update")]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.Low)]
    public class HarmonyPatch_Binoculars_Update
    {
        static void Prefix()
        {
            receiverAutoOff.RestartAutoOffAll();
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(EngineControls), "SetStateAnchorDownStateToAnchors")]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.Low)]
    public class HarmonyPatch_EngineControls_SetStateAnchorDownStateToAnchors
    {
        static void Prefix()
        {
            receiverAutoOff.RestartAutoOffAll();
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(EngineControls), "ToggleRemoteAnchorsNetworked")]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.Low)]
    public class HarmonyPatch_EngineControls_ToggleRemoteAnchorsNetworked
    {
        static void Prefix()
        {
            receiverAutoOff.RestartAutoOffAll();
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(Handheld_Compass), "Update")]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.Low)]
    public class HarmonyPatch_Handheld_Compass_Update
    {
        static void Prefix()
        {
            receiverAutoOff.RestartAutoOffAll();
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(MotorWheel), "OnButtonPressed_ChangeDirection")]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.Low)]
    public class HarmonyPatch_MotorWheel_OnButtonPressedChangeDirection
    {
        static void Prefix()
        {
            receiverAutoOff.RestartAutoOffAll();
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(MotorWheel), "OnButtonPressed_ToggleEngine")]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.Low)]
    public class HarmonyPatch_MotorWheel_OnButtonPressedToggleEngine
    {
        static void Prefix()
        {
            receiverAutoOff.RestartAutoOffAll();
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(Paddle), "OnPaddle")]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.Low)]
    public class HarmonyPatch_Paddle_OnPaddle
    {
        static void Prefix()
        {
            receiverAutoOff.RestartAutoOffAll();
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(Reciever), "AddAntenna")]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.Low)]
    public class HarmonyPatch_Reciever_AddAntenna
    {
        static void Prefix(ref Reciever __instance)
        {
            receiverAutoOff.RestartAutoOff(__instance);
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(Reciever), "OnButtonCyclePressed")]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.Low)]
    public class HarmonyPatch_Reciever_OnButtonCyclePressed
    {
        static void Prefix(ref Reciever __instance)
        {
            receiverAutoOff.RestartAutoOff(__instance);
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(Reciever), "OnButtonDownPressed")]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.Low)]
    public class HarmonyPatch_Reciever_OnButtonDownPressed
    {
        static void Prefix(ref Reciever __instance)
        {
            receiverAutoOff.RestartAutoOff(__instance);
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(Reciever), "OnButtonUpPressed")]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.Low)]
    public class HarmonyPatch_Reciever_OnButtonUpPressed
    {
        static void Prefix(ref Reciever __instance)
        {
            receiverAutoOff.RestartAutoOff(__instance);
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(Reciever), "OnBatteryStateChange")]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.Low)]
    public class HarmonyPatch_Reciever_OnBatteryStateChange
    {
        static void Prefix(ref Reciever __instance)
        {
            receiverAutoOff.RestartAutoOff(__instance);
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(Reciever), "RemoveAntenna")]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.Low)]
    public class HarmonyPatch_Reciever_RemoveAntenna
    {
        static void Prefix(ref Reciever __instance)
        {
            receiverAutoOff.RestartAutoOff(__instance);
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(Sail), "Close")]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.Low)]
    public class HarmonyPatch_Sail_Close
    {
        static void Prefix()
        {
            receiverAutoOff.RestartAutoOffAll();
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(Sail), "Open")]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.Low)]
    public class HarmonyPatch_Sail_Open
    {
        static void Prefix()
        {
            receiverAutoOff.RestartAutoOffAll();
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(Sail), "Rotate")]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.Low)]
    public class HarmonyPatch_Sail_Rotate
    {
        static void Prefix()
        {
            receiverAutoOff.RestartAutoOffAll();
        }
    }
    [HarmonyLib.HarmonyPatch(typeof(SteeringWheel), "Rotate")]
    [HarmonyLib.HarmonyPriority(HarmonyLib.Priority.Low)]
    public class HarmonyPatch_SteeringWheel_Rotate
    {
        static void Prefix()
        {
            receiverAutoOff.RestartAutoOffAll();
        }
    }
}
